/*
 * ICNOVA-specific init code
 *
 * Copyright (C) 2005-2006 Atmel Corporation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */
#include <linux/bootmem.h>
#include <linux/linkage.h>
#include <linux/clk.h>
#include <linux/etherdevice.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/platform_device.h>
#include <linux/string.h>
#include <linux/types.h>
#include <linux/spi/spi.h>
#include <linux/i2c.h>

#include <asm/io.h>
#include <asm/setup.h>
#include <asm/arch/at32ap700x.h>
#include <asm/arch/board.h>
#include <asm/arch/init.h>
#include <asm/arch/portmux.h>

#include "icnova.h"
#include "led.h"
#include "btn.h"
#include "mac.h"
#include "irda.h"
#include "pwm.h"

/* */
//#include <linux/i2c-gpio.h>
#include <linux/leds.h>
/* */
#define GPIO_AC_OUTPUT_SELECT	GPIO_PIN_PB(15)
#define GPIO_AC_RESET		GPIO_PIN_PB(19)

/* Initialized by bootloader-specific startup code. */
struct tag *bootloader_tags __initdata;


static struct mci_platform_data __initdata mci0_data = {
//	.detect_pin	= GPIO_PIN_PA(15),
	.detect_pin	= GPIO_PIN_NONE,
	.wp_pin		= GPIO_PIN_NONE,
};

static struct i2c_board_info icnova_i2c[] = {
};

void __init setup_board(void)
{
	at32_map_usart(1, 0);	// USART 1: /dev/ttyS0, DB/IF-to-USB_UART-BRIDGE
	at32_map_usart(0, 1);	// USART 0: /dev/ttyS1, RF-Connector
	at32_map_usart(3, 2);	// USART 3: /dev/ttyS2, IR
	// USART2 -> Ext IRQs

	at32_setup_serial_console(0);
}

static int __init icnova_init(void)
{
	icnova_reserve_pins();

	at32_add_system_devices();

	at32_add_device_pwm(0x0D); // PWM 0, 2 & 3
	icnova_setup_pwm(2,25000000); // 25MHz
	icnova_setup_pwm(3,12000000); // 12MHz

	icnova_setup_leds();
	icnova_setup_buttons();

	at32_add_device_usart(0);
	at32_add_device_usart(1);
	icnova_setup_irda(at32_add_device_usart(2));

	set_hw_addr(at32_add_device_eth(0, &eth_data[0]));
#ifdef CONFIG_BOARD_ICNOVA_MACB
	set_hw_addr(at32_add_device_eth(1, &eth_data[1]));
#endif

	at32_add_device_twi(0,icnova_i2c,ARRAY_SIZE(icnova_i2c));
	at32_add_device_mci(0, &mci0_data);
	at32_add_device_usba(0, NULL);

	at32_select_gpio(GPIO_AC_OUTPUT_SELECT,AT32_GPIOF_OUTPUT);
	at32_select_gpio(GPIO_AC_RESET,AT32_GPIOF_OUTPUT);
//	at32_add_device_ac97c(0);

	return 0;
}
postcore_initcall(icnova_init);
