/*
 * ICNOVA setup code
 *
 * Copyright (C) 2007 Atmel Corporation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */
#ifndef __ARCH_AVR32_BOARDS_ICNOVA_ICNOVA_H
#define __ARCH_AVR32_BOARDS_ICNOVA_ICNOVA_H

#define CONFIG_BOARD_ICNOVA_BASE_CP2102 /* + wb */

#include <asm/arch/portmux.h>
#include <asm/arch/at32ap700x.h>
/*
 * ICNOVA uses 32-bit SDRAM interface. Reserve the
 * SDRAM-specific pins so that nobody messes with them.
 */
inline static void icnova_reserve_pins(void) {
	int i;
	for(i=15; i > 0; i--) 
		at32_reserve_pin(GPIO_PIN_PE(i));	/* DATA[31:16]	*/
}

#endif /* __ARCH_AVR32_BOARDS_ICNOVA_ICNOVA_H */
