/*
 * This code is just to set up the SPI-Interface, if it is needed
 *
 * (C) 2008 by Benjamin Tietz <benjamin.tietz@in-circuit.de>
 */

#include <linux/kernel.h>
#include <linux/device.h>
#include <linux/bootmem.h>
#include <linux/spi/spi.h>
#include <linux/spi/ads7846.h>
#include <asm/arch/board.h>


#ifdef CONFIG_BOARD_ICNOVA_ADS7846
static int ads7846_pendown_state(void) {
	return 0;
}

static struct ads7846_platform_data ads_info = {
	.model			= 7846,
	.vref_delay_usecs	= 100,
	.get_pendown_state	= ads7846_pendown_state,
};

#endif

static struct spi_board_info spi0_board_info[] __initdata = {
#ifdef CONFIG_BOARD_ICNOVA_ADS7846
	{
		.modalias	= "ads7846",
		.max_speed_hz	= 1000000,
		.chip_select	= CONFIG_BOARD_ICNOVA_ADS7846_CS,
//		.mode		= SPI_MODE_0,
		.platform_data	= &ads_info,
#ifdef CONFIG_BOARD_ICNOVA_ADS7846_HAS_IRQ
		.irq		= CONFIG_BOARD_ICNOVA_ADS7846_IRQ + 64,
#else
		.irq		= -1,
#endif
		.bus_num	= 0,
	},
#endif
};

static int icnova_add_spi(void) {
	at32_add_device_spi(0, spi0_board_info, ARRAY_SIZE(spi0_board_info));
	return 0;
}

device_initcall(icnova_add_spi);
