/*
 * This just sets up the USB-Host controller
 *
 * (C) 2008 by Benjamin Tietz <benjamin@micronet24.de>
 * licensed under the terms of the GPLv2
 */

#include <linux/init.h>
#include <linux/platform_device.h>
#include <asm/arch/at32ap700x.h>
#include <asm/arch/board.h>
#include <asm/arch/portmux.h>
#include "usb.h"

//#define USB_NAME "icnova-ehci"
#define USB_NAME "isp1761"

static struct resource icnova_ehci_res[] __initdata = {
	{
		.start = USB_MEM_START,
		.end = USB_MEM_START + USB_MEM_SIZE,
		.flags = IORESOURCE_MEM,
	},
	{
		.start = USB_IRQ,
		.end = USB_IRQ,
		.flags = IORESOURCE_IRQ,
	},
	{
		.start = USB_DMA,
		.end = USB_DMA,
		.flags = IORESOURCE_DMA,
	},
};

int icnova_add_usb(void) {
	int ret;
	struct platform_device *icnova_usbh;

	pr_warning("registring " USB_NAME "\n");
	at32_select_periph(GPIO_PIN_PB(26), GPIO_PERIPH_B, 0);
	at32_select_periph(GPIO_PIN_PB(24), GPIO_PERIPH_A, 0);
	at32_select_gpio(USB_NRESET,AT32_GPIOF_OUTPUT|AT32_GPIOF_HIGH);
	at32_select_gpio(USB_SUSPEND,AT32_GPIOF_OUTPUT);
	icnova_usbh = platform_device_alloc(USB_NAME,0);
	if(!icnova_usbh) return 1;

	ret = platform_device_add_resources(icnova_usbh,icnova_ehci_res,
			ARRAY_SIZE(icnova_ehci_res));
	if(ret) goto err_add_res;

	ret = platform_device_add(icnova_usbh);
	if(ret) goto err_dev_add;
	return 0;

err_dev_add:
err_add_res:
	platform_device_put(icnova_usbh);
	pr_warning(USB_NAME " failed.\n");
	return ret;
}
device_initcall(icnova_add_usb);
